﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Security;
using System.Text;

namespace CRMRates
{
    public static class EventLogger
    {
        public static void ExitWithMessage(string Message, EventLogEntryType messageType, int exitCode)
        {
            WriteEventLog(Message, messageType, exitCode);
            Environment.Exit(exitCode);
        }

        public static void WriteEventLog(string Message, EventLogEntryType messageType, int eventID)
        {
            //ID: 5-button pressed. 0-info.
            const string sSource = "CRMRates";
            const string sLog = "Application";
            PrepareEventLog(sSource, sLog);
            try
            {
                //EventLog.WriteEntry(sSource, Message);
                EventLog.WriteEntry(sSource, Message, messageType, eventID);
            }
            catch (Exception)
            {
                return;
            }
        }

        public static void PrepareEventLog(string sSource = "CRMRates", string sLog = "Application")
        {
            try
            {
                if (!EventLog.SourceExists(sSource))
                    EventLog.CreateEventSource(sSource, sLog);
            }
            catch (SecurityException)
            {
                return;
            }
        }
    }
}
